#!/usr/local/bin/ruby

=begin
mgp2noteϥץ쥼ơȯɽѤθƤȤ뤿
뤿ΥġܻؤƤޤ

mgpե˰ʲ̿դä

	%%begin_comment: Ȥκǽ
		̿˶ޤ줿ƤHTMLǰǤʤʸ
		HTMLѤѴ<PRE></PRE>Ȥɽ
	%%end_comment: ȤκǸ

ץȥפǤϰϻȤ鷺ǲ褹
=end


# 
MGPDIR = "slides"
IMAGE_SUFFIX = "jpg"
MGPFILE = "prog0-lecture-embed.mgp"

HTML_HEADER = <<HTML_HEADER
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"
    "http://www.w3.org/TR/REC-html40/strict.dtd">
<HTML lang=ja>
<HEAD>
<TITLE>[MagicPoint] Presentation</TITLE>
<LINK rel="STYLESHEET" href="mgp2note.css" type="text/css">
<META http-equiv="Content-Type" content="text/html; charset=EUC-JP">
</HEAD>
<BODY>
HTML_HEADER

HTML_FOOTER = <<HTML_FOOTER
<HR>
<DIV class="date">
<address>Yasuhiro Abe &lt;yasu@dengaku.org&gt;</address>
Last modified: #{Time.now.to_s}
</DIV>
</BODY></HTML>
HTML_FOOTER

# ѿ
@images = Array.new
@images_num = 0
@css_update = true # after it must be set to FALSE

# main
Dir.foreach(MGPDIR) { |file|
  next if FileTest.directory?(file)
  if file =~ "mgp[0-9]{5,5}\.#{IMAGE_SUFFIX}$"
    # image file
    @images += file
  end
  @images_num = @images.size
}

# parse MGP file (with NKF to produce EUC stream)
page_index = -1
page_title = Hash.new
page_state = 0
page_fp = ""
open("|nkf -e "+MGPFILE).each_line{ |line|
  line.chop!

  # detect begin_comment directive
  if line =~ /^\%\%begin_comment/i
    page_state = 1
    page_fp << "<PRE>\n"
    next
  end

  if line =~ /^\%\%end_comment/i
    page_state = 0
    page_fp << "</PRE>\n"
    next
  end
  # when it's in the comment mode
  if page_state == 1
    # processing for HTML
    line.sub!("^%%","")
    page_fp <<  line + "\n"
    # add more operations ...

    next
  end

  if line =~ /^\%page/i
    page_index += 1
    # clean up process
    page_fp << HTML_FOOTER
    page_title[@images[page_index]] = ""
    next
  end

  if page_title.empty? || page_title[@images[page_index]].empty?
    # skip blanks, comments, and directives
    if line =~ /^\%/ || line.empty?
      next
    else
      # INIT process per page
      page_fp = open(MGPDIR+File::Separator+@images[page_index].to_s+".html", "w")
      # save page title
      page_title[@images[page_index]] = line

      # produce HTML file
      page_fp << HTML_HEADER
      page_fp << "<H1>#{page_title[@images[page_index]]}</H1>\n"
      page_fp << "<IMG src=" + @images[page_index] +">\n"
    end
  end
}

# create CSS file
if ! FileTest.exist?(MGPDIR+File::Separator+"mgp2note.css") || @css_update
  page_fp = open(MGPDIR+File::Separator+"mgp2note.css", "w")
  page_fp << <<EOF
BODY {
  background: #efefef;
  color: #8b475d;
 margin-left: 0.5em;
  margin-right: 0.5em;
}
H1 {
  text-align: center;
  color: midnightblue;
  margin-left: 0.1em;
}
PRE {
  margin-left:  2.0em;
  margin-right: 2.0em;
}
IMG {
  align: center;
}
EOF
  page_fp.close
end

# create main-index html file
page_fp = open(MGPDIR+File::Separator+"images-index.html", "w")
page_fp << HTML_HEADER
page_fp << "<H1>MagicPoint Slide Show</H1>"
page_fp << "<UL>\n"
@images.each {|image|
  page_fp << "  <LI><A href=" + image + ".html>" + page_title[image] + "</A>\n"
  # page_fp << "<BR><IMG src=" + image + ">\n"
}
page_fp << "</UL>\n"
page_fp << HTML_FOOTER
